<?php
# ***** BEGIN LICENSE BLOCK *****
# This is Contact, a plugin for DotClear. 
# Copyright (c) 2005 k-net. All rights reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


$core->addBehavior('coreInitWikiSimpleComment',array('customCode','initWikiComment'));

class tplCustomCode
{
	
	public static function toolbar($attr) {
		global $core;
		
		$res = '';
		
		$config = customCode::getConfig();
		
		foreach ($config['tags'] as $tag) {
			if ($tag['on']) {
				if (!empty($tag['img'])) {
					$res .= ' <img src="'.$tag['img'].'" title="'.(!empty($tag['cap']) ? $tag['cap'] : '').'" alt="'.(!empty($tag['abbr']) ? $tag['abbr'] : '').'" onclick="javascript:customCodeInsertTag(\''.$attr['textarea'].'\', \''.str_replace('"','&quot;',html::escapeJS($tag['df']['be'])).'\', \''.str_replace('"','&quot;',html::escapeJS($tag['df']['in'])).'\', \''.str_replace('"','&quot;',html::escapeJS($tag['df']['af'])).'\');" style="cursor:pointer" />';
				} elseif (!empty($tag['abbr'])) {
					$res .= ' <button type="button" title="'.$tag['cap'].'" onclick="javascript:customCodeInsertTag(\''.$attr['textarea'].'\', \''.str_replace('"','&quot;',html::escapeJS($tag['df']['be'])).'\', \''.str_replace('"','&quot;',html::escapeJS($tag['df']['in'])).'\', \''.str_replace('"','&quot;',html::escapeJS($tag['df']['af'])).'\');" style="cursor:pointer">'.$tag['abbr'].'</button>';
				}
			}
		}
		
		// original function from http://www.asp-php.net/scripts/scripting/addtext.php
		/*
		function customCodeInsertTag(textarea, tagbef, taginn, tagaft) {
			textarea = document.getElementById(textarea);
			if (textarea.createTextRange) {
				var text;
				textarea.focus(textarea.caretPos);
				textarea.caretPos = document.selection.createRange().duplicate();
				if (textarea.caretPos.text.length>0) {
					//gère les espace de fin de sélection. Un double-click sélectionne le mot
					//+ un espace qu\'on ne souhaite pas forcément...
					var sel = textarea.caretPos.text;
					textarea.caretPos.text = tagbef+sel+tagaft;
				} else
					textarea.caretPos.text = tagbef+taginn+tagaft;
			} else
				textarea.value += tagbef+taginn+tagaft;
		}
		//*/
		return "\n".
		'        <script type="text/javascript"> function customCodeInsertTag(textarea, tagbef, taginn, tagaft) { textarea = document.getElementById(textarea); if (textarea.createTextRange) { var text; textarea.focus(textarea.caretPos); textarea.caretPos = document.selection.createRange().duplicate(); if (textarea.caretPos.text.length>0) { var sel = textarea.caretPos.text; textarea.caretPos.text = tagbef+sel+tagaft; } else textarea.caretPos.text = tagbef+taginn+tagaft; } else textarea.value += tagbef+taginn+tagaft; } </script>'."\n".
		'        '.sprintf($config['toolbartpl'], $res)."\n".
		'        ';
	}
}

$core->tpl->addValue('CustomCodeToolbar',array('tplCustomCode','toolbar'));

?>